<template>
  <div
    v-if="sportsForDisplay.length > 0"
    class="h-[428px] w-screen ml-[calc(50%-50vw)] best-sport-container"
  >
    <div class="container mx-[auto] relative">
      <div class="sp-background">
        <div id="slider-sport-men" class="sport-men-image">
          <img
            id="best-sport-banner-1"
            class="img-slider active"
            :src="
              getAssetImage(
                `assets/theme/cool_88/desktop/home/best_sport_banner_1.png`
              )
            "
          />
          <img
            id="best-sport-banner-2"
            class="img-slider"
            :src="
              getAssetImage(
                `assets/theme/cool_88/desktop/home/best_sport_banner_2.png`
              )
            "
          />
          <img
            id="best-sport-banner-3"
            class="img-slider"
            :src="
              getAssetImage(
                `assets/theme/cool_88/desktop/home/best_sport_banner_3.png`
              )
            "
          />
        </div>
        <img
          :src="getAssetImage('assets/theme/common/images/best_sport_bg_1.png')"
          class="bg-transparent-w"
        />
      </div>
      <div class="grid grid-cols-2 pt-[64px] relative z-10">
        <div>
          <!-- <h2 class="title">{{ indexBlogI.Text }}</h2> -->
          <div class="mt-[28px]">
            <c88d-button-with-person
              v-for="(sport, index) in sportsForDisplay"
              :key="index"
              class="mb-[20px]"
              :is-multiple-provider="providerCount[sport.GameProviderName] > 1"
              :class="{
                active: selectedGame && selectedGame.GameId === sport.GameId,
              }"
              :image-player="
                getAssetImage(
                  `assets/theme/cool_88/desktop/home/best_sport_icon_${
                    index + 1
                  }.png`
                )
              "
              :logo="getProviderLogo(sport.GameProviderName)"
              :title="sport.EnglishGameName"
              :text="sport.EnglishGameName"
              @click="handleClick(sport, index)"
            />
          </div>
        </div>
        <div class="ml-[-23px]">
          <h2 class="title text-center pl-[20px]">
            {{ $t("upcoming_event") }}
          </h2>
          <div class="mt-[28px] flex gap-x-5">
            <div class="w-[160px]">
              <template
                v-if="
                  selectedGame && getProviderLogo(selectedGame.GameProviderName)
                "
              >
                <img
                  ref="rightLogo"
                  :src="getProviderLogo(selectedGame.GameProviderName)"
                  class="w-[129px]"
                />
                <div class="h-[90px] mt-[25px] text-[16px] leading-[19px]">
                  {{
                    $t(
                      "enjoy_world_class_online_sports_book_with_the_best_odds"
                    )
                  }}
                </div>
                <nuxt-link
                  :to="
                    isAuthenticated
                      ? `/Game/${selectedGame.GameId}?tab=Sports&&entrance=${EnumEntranceLocation.GameLobby}`
                      : '/login'
                  "
                >
                  <el-button type="primary">{{ $t("play_now") }}</el-button>
                </nuxt-link>
              </template>
            </div>
            <div class="w-[444px] h-[208px] relative sport-game-popular-match">
              <sport-popular-match variant="Carousel" />
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, computed, watch } from "vue";
import _ from "lodash";
import C88dButtonWithPerson from "@/components/theme/desktop/cool88/components/C88dButtonWithPerson.client.vue";
import { store } from "@/store";
import themePropertyHelper from "@/utils/themePropertyHelper";
import commonHelper from "@/utils/commonHelper";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import textHelper from "@/utils/formatHelpers/textFormatHelper";
import { IGame } from "@/models/IGetPlayableGamesResponse";

export default defineComponent({
  components: {
    C88dButtonWithPerson,
  },
  setup() {
    const { getAssetImage } = commonHelper;
    const rightLogo = ref<Element | undefined>();
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );

    const isAuthenticated = computed(() => store.state.auth);
    const isRecommendMatchEnabled = computed(
      (): boolean =>
        !themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "sportsbook_recommend_matches"
        ).IsHidden
    );
    const sabaBg = `url(${getAssetImage(
      "assets/theme/common/images/best_sport_bg.png"
    )})`;
    const providerFeature = computed(() => store.state.gameProviders.Games);
    const sportGameProvider = _.uniqBy(
      providerFeature.value?.filter(
        (item) => _.toUpper(item.TabType) === _.toUpper("sports")
      ),
      "GameProviderName"
    );
    const sportsForDisplay = computed(() => {
      const sports = sportGameProvider;
      if (sports.length > 3) return sports.slice(0, 3);
      return sports;
    });
    const selectedGame = ref<IGame | undefined>(
      _.first(sportsForDisplay.value)
    );

    const getProviderLogo = (providerName: string): string => {
      try {
        const converted = textHelper.convertString(providerName, true);
        const fileName = `provider_logo_${converted}.png`;
        return getAssetImage(
          `assets/theme/cool_88/desktop/logos/providers/${fileName}`
        );
      } catch (error) {
        return "";
      }
    };
    const handleSlider = (index: number): void => {
      const selectedSlide = document.getElementById(
        `best-sport-banner-${index}`
      );
      if (!selectedSlide || selectedSlide.classList.contains("active")) return;

      const currentActiveSlides = document.querySelectorAll(
        "img.img-slider.active"
      );
      currentActiveSlides.forEach((activeSlide) => {
        activeSlide.classList.remove("active", "fade-in");
        activeSlide.classList.add("fade-out");
      });
      selectedSlide.classList.add("active", "fade-in");
    };
    const handleClick = (sport: IGame, index: number) => {
      selectedGame.value = sport;
      handleSlider(index + 1);
    };
    const providerCount = textHelper.checkMultiple(sportsForDisplay.value);
    const animateFadeIn = (
      element: Element | null | undefined,
      duration = 0.4
    ): void => {
      if (!element) return;
      element.classList.add("logoFadeIn");
      setTimeout(() => {
        element.classList.remove("logoFadeIn");
      }, duration * 1000);
    };
    // eslint-disable-next-line require-await
    const handleActiveBtnChange = async (): Promise<void> => {
      if (!selectedGame.value) return;

      if (rightLogo.value) {
        animateFadeIn(rightLogo.value);
      }
    };
    watch(() => selectedGame.value, handleActiveBtnChange);

    return {
      rightLogo,
      EnumEntranceLocation,
      isAuthenticated,
      isRecommendMatchEnabled,
      sabaBg,
      selectedGame,
      sportsForDisplay,
      getAssetImage,
      getProviderLogo,
      handleClick,
      providerCount,
    };
  },
});
</script>

<style scoped lang="scss">
.el-divider--vertical {
  height: 100%;
  border-left: 1px solid var(--primary);
  margin: 0;
}
.best-sport-container {
  background-image: v-bind(sabaBg);
  font-family: "Roboto";
  color: var(--text5);
  padding-left: 1rem;
  padding-right: 1rem;
  overflow: hidden;
  position: relative;
  background-repeat: round;
}

.sp-background {
  > .sport-men-image {
    position: absolute;
    z-index: 0;
    height: 428px;
    overflow: visible;
    width: 100%;

    > img {
      position: absolute;

      &.active {
        opacity: 1;
        transform: translateX(100px);
      }
      &:not(.active) {
        opacity: 0;
      }
    }
  }

  > .bg-transparent-w {
    position: absolute;
    z-index: 1;
    left: 488px;
  }
}

h2.title {
  font-weight: 800;
  font-size: 24px;
  line-height: 28px;
  color: var(--secondary);
}

.el-button {
  width: 160px;
  height: 36px;
  margin-top: 15px;
}
.fade-out {
  animation: fade-out 0.5s forwards;
  animation-iteration-count: 1;
}

.fade-in {
  animation: fade-in 1s forwards;
  animation-iteration-count: 1;
  transition: all 1s ease;
}

@keyframes fade-out {
  0% {
    transform: translateX(100px);
    opacity: 1;
  }

  99% {
    transform: translateX(150px);
    opacity: 0;
  }

  100% {
    transform: translateX(0px);
    opacity: 0;
  }
}

@keyframes fade-in {
  0% {
    transform: translateX(-50vw);
    opacity: 0;
  }

  50% {
    transform: translateX(120px);
    opacity: 1;
  }
  100% {
    transform: translateX(100px);
    opacity: 1;
  }
}
@keyframes logoFadeIn {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}

.logoFadeIn {
  animation: logoFadeIn 0.4s ease-in-out forwards;
}
:deep(.sport-game-popular-match .popular-match-card-desktop) {
  width: 360px;
}
</style>
